import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import path from 'path';
import fs from 'fs';
import loaderUtils from 'loader-utils';
import parsePropValues from './parsePropValues';
import loadConfig from '@temporg/config-loader';
export default function componentExamplesLoader(source, map, meta) {
  this.cacheable && this.cacheable();
  var loader = this;
  var callback = loader.async();

  var config = _objectSpread({
    maxExamples: 500
  }, loadConfig('examples', {}));

  var generateComponentExamples = require.resolve('./generateComponentExamples');

  var renderPage = require.resolve('./renderPage');

  var renderExample = require.resolve('./renderExample');

  var configPath = "!!".concat(loaderUtils.getRemainingRequest(loader));
  var getComponentPath = typeof config.getComponentPath === 'function' ? config.getComponentPath : function (configFilePath) {
    var basePath = path.dirname(configFilePath); // try to determine component source based on where the .examples file is:

    return path.resolve(basePath, configFilePath.includes('__examples__') ? '../index.js' : './index.js');
  };
  var componentPath = getComponentPath(this.resourcePath);
  fs.readFile("".concat(componentPath).concat(!componentPath.includes('.') ? '.js' : ''), 'utf8', function (err, componentSrc) {
    // if (err) return callback(err)
    err && loader.emitWarning(err);
    var generatedPropValues = {};

    if (!err) {
      loader.addDependency(componentPath);

      try {
        generatedPropValues = parsePropValues(componentSrc);
      } catch (error) {
        loader.emitWarning(error);
      }
    }

    var result = "\nconst generateComponentExamples = require(".concat(JSON.stringify(generateComponentExamples), ").default\nconst renderPage = require(").concat(JSON.stringify(renderPage), ").default\nconst renderExample = require(").concat(JSON.stringify(renderExample), ").default\nconst config = require(").concat(JSON.stringify(configPath), ").default\n\n// merge in generated prop values:\nconfig.propValues = Object.assign(\n  ").concat(JSON.stringify(generatedPropValues), ",\n  config.propValues || {}\n)\nconst Component = require(").concat(JSON.stringify(componentPath), ").default\n\nconfig.maxExamples = Boolean(config.maxExamples) ? config.maxExamples : ").concat(config.maxExamples, "\n\nmodule.exports = {\n componentName: Component.displayName || Component.name,\n sections: generateComponentExamples(Component, config),\n renderPage: config.renderPage || renderPage,\n renderExample: config.renderExample || renderExample\n}\n");
    return callback(null, result, map);
  });
}