import React from 'react';
import { View } from '@temporg/ui-view';
import { Tooltip } from '@temporg/ui-tooltip';
import { IconButton } from '@temporg/ui-buttons';
import { IconInfoLine } from '@temporg/ui-icons';

var _ref2 = /*#__PURE__*/React.createElement(IconButton, {
  size: "small",
  renderIcon: IconInfoLine,
  screenReaderLabel: "props"
});

export default function renderExample(_ref) {
  var Component = _ref.Component,
      componentProps = _ref.componentProps,
      exampleProps = _ref.exampleProps,
      key = _ref.key;
  return /*#__PURE__*/React.createElement(View, Object.assign({
    key: key,
    display: "block",
    padding: "small",
    background: exampleProps.background || 'primary',
    width: exampleProps.width || '100%',
    maxWidth: exampleProps.maxWidth || 'none',
    height: exampleProps.height || 'auto',
    maxHeight: exampleProps.maxHeight || 'none'
  }, exampleProps), /*#__PURE__*/React.createElement(Component, componentProps), /*#__PURE__*/React.createElement(Tooltip, {
    renderTip: /*#__PURE__*/React.createElement("pre", null, JSON.stringify(componentProps, null, 2)),
    placement: "bottom",
    on: ['click']
  }, _ref2));
}