"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = componentExamplesLoader;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _loaderUtils = _interopRequireDefault(require("loader-utils"));

var _parsePropValues = _interopRequireDefault(require("./parsePropValues"));

var _configLoader = _interopRequireDefault(require("@temporg/config-loader"));

function componentExamplesLoader(source, map, meta) {
  this.cacheable && this.cacheable();
  var loader = this;
  var callback = loader.async();
  var config = (0, _objectSpread2.default)({
    maxExamples: 500
  }, (0, _configLoader.default)('examples', {}));

  var generateComponentExamples = require.resolve('./generateComponentExamples');

  var renderPage = require.resolve('./renderPage');

  var renderExample = require.resolve('./renderExample');

  var configPath = "!!".concat(_loaderUtils.default.getRemainingRequest(loader));
  var getComponentPath = typeof config.getComponentPath === 'function' ? config.getComponentPath : function (configFilePath) {
    var basePath = _path.default.dirname(configFilePath); // try to determine component source based on where the .examples file is:


    return _path.default.resolve(basePath, configFilePath.includes('__examples__') ? '../index.js' : './index.js');
  };
  var componentPath = getComponentPath(this.resourcePath);

  _fs.default.readFile("".concat(componentPath).concat(!componentPath.includes('.') ? '.js' : ''), 'utf8', function (err, componentSrc) {
    // if (err) return callback(err)
    err && loader.emitWarning(err);
    var generatedPropValues = {};

    if (!err) {
      loader.addDependency(componentPath);

      try {
        generatedPropValues = (0, _parsePropValues.default)(componentSrc);
      } catch (error) {
        loader.emitWarning(error);
      }
    }

    var result = "\nconst generateComponentExamples = require(".concat(JSON.stringify(generateComponentExamples), ").default\nconst renderPage = require(").concat(JSON.stringify(renderPage), ").default\nconst renderExample = require(").concat(JSON.stringify(renderExample), ").default\nconst config = require(").concat(JSON.stringify(configPath), ").default\n\n// merge in generated prop values:\nconfig.propValues = Object.assign(\n  ").concat(JSON.stringify(generatedPropValues), ",\n  config.propValues || {}\n)\nconst Component = require(").concat(JSON.stringify(componentPath), ").default\n\nconfig.maxExamples = Boolean(config.maxExamples) ? config.maxExamples : ").concat(config.maxExamples, "\n\nmodule.exports = {\n componentName: Component.displayName || Component.name,\n sections: generateComponentExamples(Component, config),\n renderPage: config.renderPage || renderPage,\n renderExample: config.renderExample || renderExample\n}\n");
    return callback(null, result, map);
  });
}