import React from 'react'
import { View } from '@temporg/ui-view'
import { Tooltip } from '@temporg/ui-tooltip'
import { IconButton } from '@temporg/ui-buttons'
import { IconInfoLine } from '@temporg/ui-icons'

export default function renderExample ({ Component, componentProps, exampleProps, key }) {
  return (
    <View
      key={key}
      display="block"
      padding="small"
      background={exampleProps.background || 'primary'}
      width={exampleProps.width || '100%'}
      maxWidth={exampleProps.maxWidth || 'none'}
      height={exampleProps.height || 'auto'}
      maxHeight={exampleProps.maxHeight || 'none'}
      {...exampleProps}
    >
      <Component {...componentProps} />
      <Tooltip
        renderTip={<pre>{JSON.stringify(componentProps,null,2)}</pre>}
        placement="bottom"
        on={['click']}
      >
        <IconButton size="small"
          renderIcon={IconInfoLine}
          screenReaderLabel="props"
        />
      </Tooltip>
    </View>
  )
}
